package algorithms;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import objects.Template;

public class DecisionRandom extends Decision {

    @Override
    public void importGallery(List<Template> templatesGallery) {
        List<String> gallery = new ArrayList();
        for (Template template : templatesGallery) {
            gallery.add(template.getSubject());
        }
        setGallery(gallery);
    }

    @Override
    public String decide(Template templateProbe) {
        List<String> gallery = getGallery();
        return gallery.get(new Random().nextInt(gallery.size()));
    }
}
