package algorithms;

import Jama.Matrix;
import objects.Template;

public final class DistanceTemplatesMahalanobis extends DistanceTemplates {

    public DistanceTemplatesMahalanobis() {
    }

    @Override
    public double getDistance(Template template1, Template template2) {
        Matrix diff = template1.getMatrix().minus(template2.getMatrix());
        return Math.sqrt(diff.transpose().times(getDistanceTemplatesMatrix()).times(diff).get(0, 0));
    }
}
